use crate::prelude::*;
use crate::std_bis::*;

pub mod ferris;

pub mod traits {
	use super::*;

	pub trait Entity {}

	pub trait Walker {
		fn walk(&mut self, board: &Board, direction: Direction);
	}
}

pub enum Entity {
	Ferris(Box<ferris::Ferris>),
}

pub enum WalkError {
	OutOfBoard,
}
