use super::traits::*;
use crate::board::*;

pub struct Ferris {
	position: (i32, i32),
}

impl Entity for Ferris {}

impl Position for Ferris {
	fn get_position(&self) -> (i32, i32) {
		self.position
	}
}

impl Walker for Ferris {
	fn walk(&mut self, board: &Board, direction: Direction) {
		let dpos = direction.to_position::<i32>();
		self.position.0 += dpos.0;
		self.position.1 += dpos.1;
	}
}
